package org.jeecg.modules.studytourOrder.controller;

import java.io.UnsupportedEncodingException;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.vo.LoginUser;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.studytourOrder.entity.StudytourOrderPerson;
import org.jeecg.modules.studytourOrder.entity.StudytourOrder;
import org.jeecg.modules.studytourOrder.vo.StudytourOrderPage;
import org.jeecg.modules.studytourOrder.service.IStudytourOrderService;
import org.jeecg.modules.studytourOrder.service.IStudytourOrderPersonService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 订单信息表
 * @Author: jeecg-boot
 * @Date:   2025-09-10
 * @Version: V1.0
 */
@Api(tags="订单信息表")
@RestController
@RequestMapping("/studytourOrder/studytourOrder")
@Slf4j
public class StudytourOrderController {
	@Autowired
	private IStudytourOrderService studytourOrderService;
	@Autowired
	private IStudytourOrderPersonService studytourOrderPersonService;
	
	/**
	 * 分页列表查询
	 *
	 * @param studytourOrder
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "订单信息表-分页列表查询")
	@ApiOperation(value="订单信息表-分页列表查询", notes="订单信息表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<StudytourOrder>> queryPageList(StudytourOrder studytourOrder,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StudytourOrder> queryWrapper = QueryGenerator.initQueryWrapper(studytourOrder, req.getParameterMap());
		Page<StudytourOrder> page = new Page<StudytourOrder>(pageNo, pageSize);
		IPage<StudytourOrder> pageList = studytourOrderService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param studytourOrderPage
	 * @return
	 */
	@AutoLog(value = "订单信息表-添加")
	@ApiOperation(value="订单信息表-添加", notes="订单信息表-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StudytourOrderPage studytourOrderPage) {
		StudytourOrder studytourOrder = new StudytourOrder();
		BeanUtils.copyProperties(studytourOrderPage, studytourOrder);
		studytourOrderService.saveMain(studytourOrder, studytourOrderPage.getStudytourOrderPersonList());
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param studytourOrderPage
	 * @return
	 */
	@AutoLog(value = "订单信息表-编辑")
	@ApiOperation(value="订单信息表-编辑", notes="订单信息表-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StudytourOrderPage studytourOrderPage) {
		StudytourOrder studytourOrder = new StudytourOrder();
		BeanUtils.copyProperties(studytourOrderPage, studytourOrder);
		StudytourOrder studytourOrderEntity = studytourOrderService.getById(studytourOrder.getId());
		if(studytourOrderEntity==null) {
			return Result.error("未找到对应数据");
		}
		studytourOrderService.updateMain(studytourOrder, studytourOrderPage.getStudytourOrderPersonList());
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "订单信息表-通过id删除")
	@ApiOperation(value="订单信息表-通过id删除", notes="订单信息表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		studytourOrderService.delMain(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "订单信息表-批量删除")
	@ApiOperation(value="订单信息表-批量删除", notes="订单信息表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.studytourOrderService.delBatchMain(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "订单信息表-通过id查询")
	@ApiOperation(value="订单信息表-通过id查询", notes="订单信息表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<StudytourOrder> queryById(@RequestParam(name="id",required=true) String id) {
		StudytourOrder studytourOrder = studytourOrderService.getById(id);
		if(studytourOrder==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(studytourOrder);

	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "订单人员表通过主表ID查询")
	@ApiOperation(value="订单人员表主表ID查询", notes="订单人员表-通主表ID查询")
	@GetMapping(value = "/queryStudytourOrderPersonByMainId")
	public Result<List<StudytourOrderPerson>> queryStudytourOrderPersonListByMainId(@RequestParam(name="id",required=true) String id) {
		List<StudytourOrderPerson> studytourOrderPersonList = studytourOrderPersonService.selectByMainId(id);
		return Result.OK(studytourOrderPersonList);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param studytourOrder
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StudytourOrder studytourOrder) {
      // Step.1 组装查询条件查询数据
      QueryWrapper<StudytourOrder> queryWrapper = QueryGenerator.initQueryWrapper(studytourOrder, request.getParameterMap());
      LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();

      //Step.2 获取导出数据
      List<StudytourOrder> queryList = studytourOrderService.list(queryWrapper);
      // 过滤选中数据
      String selections = request.getParameter("selections");
      List<StudytourOrder> studytourOrderList = new ArrayList<StudytourOrder>();
      if(oConvertUtils.isEmpty(selections)) {
          studytourOrderList = queryList;
      }else {
          List<String> selectionList = Arrays.asList(selections.split(","));
          studytourOrderList = queryList.stream().filter(item -> selectionList.contains(item.getId())).collect(Collectors.toList());
      }

      // Step.3 组装pageList
      List<StudytourOrderPage> pageList = new ArrayList<StudytourOrderPage>();
      for (StudytourOrder main : studytourOrderList) {
          StudytourOrderPage vo = new StudytourOrderPage();
          BeanUtils.copyProperties(main, vo);
          List<StudytourOrderPerson> studytourOrderPersonList = studytourOrderPersonService.selectByMainId(main.getId());
          vo.setStudytourOrderPersonList(studytourOrderPersonList);
          pageList.add(vo);
      }

      // Step.4 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      mv.addObject(NormalExcelConstants.FILE_NAME, "订单信息表列表");
      mv.addObject(NormalExcelConstants.CLASS, StudytourOrderPage.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("订单信息表数据", "导出人:"+sysUser.getRealname(), "订单信息表"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
    }

    /**
    * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<StudytourOrderPage> list = ExcelImportUtil.importExcel(file.getInputStream(), StudytourOrderPage.class, params);
              for (StudytourOrderPage page : list) {
                  StudytourOrder po = new StudytourOrder();
                  BeanUtils.copyProperties(page, po);
                  studytourOrderService.saveMain(po, page.getStudytourOrderPersonList());
              }
              return Result.OK("文件导入成功！数据行数:" + list.size());
          } catch (Exception e) {
              log.error(e.getMessage(),e);
              return Result.error("文件导入失败:"+e.getMessage());
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.OK("文件导入失败！");
    }

}
